#line 145 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

#ifndef PANAREA_H_INCLUDED
#define PANAREA_H_INCLUDED

#include <FXWindow.h>

namespace FX {
	
class FXAPI PanArea : public FXWindow {
	FXDECLARE(PanArea)
protected:
	PanArea();
private:
	PanArea(const PanArea&);
	PanArea &operator=(const PanArea&);
public:

	PanArea(FXComposite* p, FXObject* tgt, int sel,
		FXuint opts=FRAME_NORMAL,
		FXint x=0,FXint y=0,FXint w=0,FXint h=0);
	virtual ~PanArea();

	virtual bool canFocus() const;
//virtual void create();
//virtual void detach();
//virtual void layout();

        enum { ID_SHOWREQ, ID_PANREQ, ID_LASTMESSAGE };

	virtual int getDefaultWidth();
	virtual int getDefaultHeight();
#line 11 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

  int DSx, DSy, DLx, DLy;
  int WSx, WSy, WLx, WLy;

#line 28 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

  FXColor bg, fg;

#line 40 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
  long onPaint(FXObject*,FXSelector,void*);
#line 249 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"

  void click_action(int x,int y);
  void doubleclick_action(int x,int y); 
  int drag_start(int x,int y);
  void motion_action(int oldx,int oldy, int newx,int newy);
  void mouse_release_action();

#line 16 "/home/dodo/PRG/zooming_stickies-1.0/src/mouse.u"

  long onLeftBtnPress(FXObject*,FXSelector,void*);
  long onLeftBtnRelease(FXObject*,FXSelector,void*);
  long onMotion(FXObject*,FXSelector,void*);
#line 24 "/home/dodo/PRG/zooming_stickies-1.0/src/mouse.u"

  int last_mouse_x, last_mouse_y;
  int click_mouse_x, click_mouse_y;
  int mouse_down;

#line 115 "/home/dodo/PRG/zooming_stickies-1.0/src/mouse.u"

 int dragging;

#line 177 "/home/dodo/PRG/zooming_stickies-1.0/src/panarea.u"
};

}

#endif


