#line 199 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

#include <stdlib.h>
#include <string.h>

#line 84 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

static int choose_best(int N, int **M, int **Y, int *sol, int row_height)
{
  int nsol, i, nrows, K, B;
  
  B= M[0][1]+row_height*1; nrows= 1;
  for(i=2;i<=N;i++)
    if (M[0][i]+row_height*i<B)
    {
       B= M[0][i]+row_height*i;
       nrows= i;
    }
  nsol= 0;
  sol[nsol++]= 0;

  while(nrows)
  {
    K= Y[sol[nsol-1]][nrows];
    sol[nsol++]= K+1;
    nrows--;
  }

  return nsol;
}
#line 115 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

static int put_words
  (int start, int end, char **words, char *string_area, int string_area_size)
{
  int w;

  for(w=start;w<end;w++)
  {
    if (w!=start) {
       if (string_area) string_area[string_area_size]= ' ';
       string_area_size++;
    }
    if (string_area)
       memcpy(string_area+string_area_size, words[w], strlen(words[w]));
    string_area_size+= strlen(words[w]);
  }

  if (string_area) string_area[string_area_size]= 0;
  string_area_size++;
  return string_area_size;
}

#line 165 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

static int **make_matrix(int N)
{
  int i,j;
  int **R;
  R= malloc(sizeof(int*)*N);
  for(i=0;i<N;i++) {
    R[i]= malloc(sizeof(int)*N);
    for(j=0;j<N;j++) R[i][j]= -1;
  }
  return R;
}

static void free_matrix(int **M, int N)
{
  int i;
  for(i=0;i<N;i++) free(M[i]);
  free(M);
}

static int max(int a,int b) { return a > b ? a: b; }
#line 10 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

char **text_layout_square(char **words, int N, int *W,
           int space_width, int row_height)
{
   int **A, **M, **Y;
   int i,j,k,r;
   int nsol; int *sol;
   int string_area_size, result_size; char *string_area; char **result;

   A= make_matrix(N);
   M= make_matrix(N+1);
   Y= make_matrix(N+1);
#line 44 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

  for(i=0;i<N;i++) {
    A[i][i]= W[i];
    for(j=i+1;j<N;j++) 
      A[i][j]= A[i][j-1]+space_width+W[j];
  } 

#line 62 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

  M[N-1][1]= A[N-1][N-1];
  for(i=0;i<N;i++) { M[i][1]= A[i][N-1]; Y[i][1]= N-1; }

  for(k=N-1;k>0;k--)
    for(r=1;r<=N-k;r++)
      for(j=k-1;j>=0;j--) 
      {
         int Z= max(M[k][r], A[j][k-1]);
         if (M[j][r+1]==-1 || Z<M[j][r+1])
         {
            M[j][r+1]= Z;
            Y[j][r+1]= k-1;
         }
      }

#line 24 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

   sol= malloc(sizeof(int)*(N+1));
   nsol= choose_best(N, M, Y, sol, row_height);

   free_matrix(A,N); 
   free_matrix(M,N+1); 
   free_matrix(Y,N+1); 

#line 141 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

  string_area_size= 0;
  for(i=0;i<nsol-1;i++)
    string_area_size= put_words(sol[i], sol[i+1], words, 0, string_area_size);
  result_size= string_area_size + nsol*sizeof(char*);

#line 33 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"
   result= malloc(result_size);
   string_area= (char*) (result + nsol);
#line 151 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"

  string_area_size= 0;
  for(i=0;i<nsol-1;i++)
  {
    result[i]= string_area+ string_area_size;
    string_area_size= put_words(sol[i], sol[i+1], words,
                                string_area, string_area_size);
  }
  result[nsol-1]= 0;

#line 36 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"
   free(sol);
   return result;
} 

#line 205 "/home/dodo/PRG/zooming_stickies-1.0/src/square_layout.u"


