#!/bin/sh

FN=`basename $PWD`

rm -Rf $FN.tgz $FN

mkdir $FN

for  X in build/*.cc build/*.h build/*.c ; do
  Y=`basename $X`
  cat src/notice $X > $FN/$Y
done

cp src/gpl-3.0.txt $FN
cp src/Makefile $FN
cp src/README $FN

tar czf $FN.tgz $FN

echo $FN.tgz created
rm -Rf $FN


